#!/bin/bash
# Repast Simphony Model Starter
# By Michael J. North and Jonathan Ozik
# 11/12/2007
# Note the Repast Simphony Directories.

PWD="${0%/*}"
cd $PWD

REPAST_SIMPHONY_ROOT=$PWD/repast.simphony/repast.simphony.runtime_$REPAST_VERSION
REPAST_SIMPHONY_BATCH=$PWD/repast.simphony/repast.simphony.batch_$REPAST_VERSION
REPAST_SIMPHONY_CORE=$PWD/repast.simphony/repast.simphony.core_$REPAST_VERSION
REPAST_SIMPHONY_SCORE=$PWD/repast.simphony/repast.simphony.score.runtime_$REPAST_VERSION

REPAST_SIMPHONY_LIB=$REPAST_SIMPHONY_ROOT/lib
REPAST_SIMPHONY_BATCH_LIB=$REPAST_SIMPHONY_BATCH/lib
REPAST_SIMPHONY_CORE_LIB=$REPAST_SIMPHONY_CORE/lib
REPAST_SIMPHONY_SCORE_LIB=$REPAST_SIMPHONY_SCORE/lib

# Define the Core Repast Simphony Directories and JARs
CP=$CP:$REPAST_SIMPHONY_ROOT/bin
CP=$CP:$REPAST_SIMPHONY_ROOT/bin-groovy
CP=$CP:$REPAST_SIMPHONY_BATCH/bin
CP=$CP:$REPAST_SIMPHONY_BATCH/bin-groovy

CP=$CP:$REPAST_SIMPHONY_LIB/*
CP=$CP:$REPAST_SIMPHONY_BATCH_LIB/*
CP=$CP:$REPAST_SIMPHONY_CORE_LIB/*
CP=$CP:$REPAST_SIMPHONY_SCORE_LIB/*
CP=$CP:./lib/helia_gis.jar;./lib/repast.simphony.bin_and_src.jar;./bin

# Change to the Default Repast Simphony Directory
cd SLUCEII20100204


# ++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Change the parameter file as needed
# Check the configuration file path as needed
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++
java -Xss32M -Xmx1024M -cp $CP repast.simphony.batch.BatchMain -params batch/aag_batch_params_lm_levels.xml -interactive sluce.aag/aag.rs 
