/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.app.lmm;

import java.awt.Color;

import repast.simphony.valueLayer.ValueLayer;
import repast.simphony.visualizationOGL2D.ValueLayerStyleOGL;

/**
 * @author sunsp
 *
 */
public class LUTypeStyle2D implements ValueLayerStyleOGL
{
	protected ValueLayer layer;
	
	public static double maxVal = 5;
	public static double minVal = 0; // zero does not count

	/* (non-Javadoc)
	 * @see repast.simphony.visualization.visualization2D.style.DefaultValueLayerStyle#getCellSize()
	 */
	@Override
	public float getCellSize()
	{
		// TODO Auto-generated method stub
		// This size must be the same as the one used for Grid display. Otherwise, their locations
		// will not match.
		// Unfortunately, it is not easy to create a style for grid within the program using Java.
		return 15.0f;
	}

	/**
	 * 
	 */
	public LUTypeStyle2D()
	{
		// TODO Auto-generated constructor stub
		super();
	}

	/* (non-Javadoc)
	 * @see repast.simphony.visualization.visualization2D.style.DefaultValueLayerStyle#getPaint(double[])
	 */
	@Override
	public Color getColor(double... coordinates)
	{
		// TODO Auto-generated method stub
		double val = this.layer.get(coordinates);
		
		if(val > LUTypeStyle2D.maxVal) LUTypeStyle2D.maxVal = val;
		if(val > 1 && val < LUTypeStyle2D.minVal) LUTypeStyle2D.minVal = val;
		
		if(val == 0.0)
		{
			return Color.green; 
		}
		else if(val == -1.0)
		{
			return Color.darkGray;
		}
		else if(val == -9999)
		{
			return Color.LIGHT_GRAY;
		}
		else
		{
			return blend(Color.blue,Color.red, (val - LUTypeStyle2D.minVal)/(maxVal-minVal));
		}
	}


	@Override
	public void init(ValueLayer layer) 
	{
		// TODO Auto-generated method stub
		this.layer = layer;
	}
	
	public static Color blend (Color color1, Color color2, double ratio)
	 {
	   float r  = (float) ratio;
	   r = (r<0.0f)?0.0f:r;
	   r = (r>1.0f)?1.0f:r;
	   float ir = 1f - r;
	   float rgb1[] = new float[3];
	   float rgb2[] = new float[3];
	   color1.getColorComponents(rgb1);
	   color2.getColorComponents(rgb2);
	   Color color = new Color (rgb1[0] * r + rgb2[0] * ir,
	                            rgb1[1] * r + rgb2[1] * ir,
	                            rgb1[2] * r + rgb2[2] * ir);
	   return color;
	 }
}
