/**
 * 
 */
package sluceii.land.development;

import java.util.Hashtable;

import sluceii.land.market.SimpleMarketAgent;
import sluceii.land.market.SimpleMarketLand;

/**
 * Land profit information record specific to a particular developer
 * @author Shipeng Sun
 *
 */
public class EstimatedLandProfitInfo<T extends SimpleMarketAgent, L extends SimpleMarketLand> 
{

	protected T developerAgent;
	protected Hashtable<L, LandProfitInfoRecord> landProfitInfo;
	
	public EstimatedLandProfitInfo(T developerAgent) 
	{
		super();
		this.developerAgent = developerAgent;
		landProfitInfo = new Hashtable<L, LandProfitInfoRecord>();
	}
	
	/**
	 * @param luObj
	 * @param piRec
	 */
	public void addRecord(L luObj, LandProfitInfoRecord piRec)
	{
		landProfitInfo.put(luObj, piRec);
	}
	
	/**
	 * @param luObj
	 * @return
	 */
	public LandProfitInfoRecord getRecord(L luObj)
	{
		if(luObj == null) return null;
		if(landProfitInfo.containsKey(luObj))
		{
			return landProfitInfo.get(luObj);
		}
		else
		{
			return null;
		}
	}
}
