/**
 * 
 */
package sluceii.land.development;

import java.util.ArrayList;

/**
 * Subdivision type class. Country, horticultural, remnant, rural lots.
 * Different types have different sizes.
 * Developers have different cost and risk perception for each type.
 * 
 * @author sunsp
 *
 */
public class SubdivisionType 
{
	public static ArrayList<SubdivisionType> subdivisionTypeCollections = new ArrayList<SubdivisionType>();
		
	protected int subdivisionTypeID;
	
	protected String subdivisionTypeName;
	
	protected float meanSize; // number of cells
	
	/**
	 * 
	 */
	public SubdivisionType(byte typeID, String typeName, float meanSize )
	{
		this.subdivisionTypeID = typeID;
		this.subdivisionTypeName = typeName;
		this.meanSize = meanSize;
	}

	/**
	 * @return the subdivisionTypeID
	 */
	public int getSubdivisionTypeID() {
		return subdivisionTypeID;
	}

	/**
	 * @param subdivisionTypeID the subdivisionTypeID to set
	 */
	public void setSubdivisionTypeID(int subdivisionTypeID) {
		this.subdivisionTypeID = subdivisionTypeID;
	}

	/**
	 * @return the subdivisionTypeName
	 */
	public String getSubdivisionTypeName() {
		return subdivisionTypeName;
	}

	/**
	 * @param subdivisionTypeName the subdivisionTypeName to set
	 */
	public void setSubdivisionTypeName(String subdivisionTypeName) {
		this.subdivisionTypeName = subdivisionTypeName;
	}

	/**
	 * @return the meanSize
	 */
	public float getMeanSize() {
		return meanSize;
	}

	/**
	 * @param meanSize the meanSize to set
	 */
	public void setMeanSize(float meanSize) {
		this.meanSize = meanSize;
	}
}
