/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.land.management;

/**
 * The irrigation behavior of an agent.
 * When, how to irrigate.
 * 
 * @author Shipeng Sun
 *
 */
public class IrrigationStrategy extends LandManagementStrategy
{
	/**
	 * Type of the irrigation behavior/strategy. <br>
	 * <pre>
	 * 0: addition of a fix amount of water 
	 * 1: addition of a fix proportion
	 * 2: set the maximum
	 * 3: set a weekly/seven day average
	 * </pre>
	 */
	protected byte type;
	
	/**
	 * The amount/quantity of irrigation
	 */
	protected double irrigationAmount;
	
	/**
	 * The day beginning to apply the strategy.
	 */
	protected int startingDay;
	
	/**
	 * The day stopping applying this strategy
	 */
	protected int endDay;
	
	/**
	 * The frequency doing the management behavior
	 */
	protected int frequencyDays;
	
	/**
	 * 
	 */
	public IrrigationStrategy()
	{
		// TODO Auto-generated constructor stub
	}

	/**
	 * 0: addition of a fix amount of water 
	 * 1: addition of a fix proportion
	 * 2: set the maximum
	 * 3: set a weekly/seven day average 
	 * @return the type
	 */
	public byte getType()
	{
		return type;
	}

	/**
	 * <pre>
	 * 0: addition of a fix amount of water 
	 * 1: addition of a fix proportion
	 * 2: set the maximum
	 * 3: set a weekly/seven day average
	 * </pre>
	 * @param type the type to set
	 */
	public void setType(byte type)
	{
		this.type = type;
	}

	/**
	 * @return the irrigationAmount
	 */
	public double getIrrigationAmount()
	{
		return irrigationAmount;
	}

	/**
	 * @param irrigationAmount the irrigationAmount to set
	 */
	public void setIrrigationAmount(double irrigationAmount)
	{
		this.irrigationAmount = irrigationAmount;
	}

	/**
	 * @return the startingDay
	 */
	public int getStartingDay()
	{
		return startingDay;
	}

	/**
	 * @param startingDay the startingDay to set
	 */
	public void setStartingDay(int startingDay)
	{
		this.startingDay = startingDay;
	}

	/**
	 * @return the endDay
	 */
	public int getEndDay()
	{
		return endDay;
	}

	/**
	 * @param endDay the endDay to set
	 */
	public void setEndDay(int endDay)
	{
		this.endDay = endDay;
	}

	/**
	 * @return the frequencyDays
	 */
	public int getFrequencyDays()
	{
		return frequencyDays;
	}

	/**
	 * @param frequencyDays the frequencyDays to set
	 */
	public void setFrequencyDays(int frequencyDays)
	{
		this.frequencyDays = frequencyDays;
	}

}
