/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.land.market.decision;

import sluceii.land.market.SimpleMarketLand;

/**
 * An interface for sellers to sell land.
 * 
 * @author Shipeng Sun
  */
public interface DecisionToSell
{
	
	/**
	 * Better specify a land object in case a land owner has multiple parcels/subdivisions.
	 * 
	 * @param landObj
	 * @return
	 */
	public boolean isToSell(SimpleMarketLand landObj);
	
	/**
	 * @param landObj
	 * @return
	 */
	public double calcSellProbability(SimpleMarketLand landObj);
	
	/**
	 * @param landObj
	 * @return
	 */
	public double calcAskPrice(SimpleMarketLand landObj);
	
	/**
	 * @param landObj
	 * @return
	 */
	public double calcWTAPrice(SimpleMarketLand landObj);
	
	/**
	 * Calculate the utility, ask, and willingness to accept for sellers.
	 * @param landObj
	 * @return
	 */
	public double[] calcUtilityAndPricesForSell(SimpleMarketLand landObj);
}
