/**
 * 
 */
package sluceii.land.market.decision;

import java.util.ArrayList;
import sluceii.land.market.SimpleMarketLand;

/**
 * This interface defines how an agent estimates the expected profit from a land parcel.
 * Currently, only developers use this kind of estimation.
 * 
 * @author Shipeng Sun
 *
 */
public interface LandProfitEstimator
{
	/**
	 * @return
	 */
	public ArrayList<Number> estimateExpectedLandProfit(SimpleMarketLand luObj, double sellerWTA, ArrayList<Double> landProperties);

	
	/**
	 * If the agent is a developer, it should try all types of development specialties
	 * @param luObj
	 * @param sellerWTA
	 * @return
	 */
	public ArrayList<Number> estimateExpectedLandProfit(SimpleMarketLand luObj, double sellerWTA);
}
