/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.land.market.exchange;

import java.util.ArrayList;

import sluceii.land.market.LandBidRecord;
import sluceii.land.market.SimpleMarketLand;


/**
 * @author Shipeng Sun
 * This is an interface for all land sellers (rural land owner, household, developer).
 * All land sellers need to implement this interface.
 * The bidding process depends on this interface.
 */
public interface LandSellingProcess<L extends SimpleMarketLand>
{
	public void putLandOnMarket(L landObj, double askPrice, double wta);
	public void putLandOnMarket(L landObj, double askPrice, double wta, ArrayList<Number> extraLandAttributes);
	public void checkBidOffers();
	public void acceptBidOffer(LandBidRecord<L,?> landBidRecord);
	public void rejectBidOffer(LandBidRecord<L,?> landBidRecord);
	public void clearTransaction(LandBidRecord<L,?> landBidRecord);
}
