/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.land.market.resource;

/**
 * This class represents the asset that an agent has.
 * It has several shared attributes, types, quantity, etc.
 * 
 * @author Shipeng Sun
 * @version 1.0
 */
public class AssetResource
{
	/**
	 * @author Shipeng Sun
	 * For urban residents, capital is the most important one. For rural farmers, land and labor
	 * are also important assests.
	 */
	public enum AssetType {capital, land, labor};
	
	/**
	 * The type of asset
	 */
	protected AssetType assetType;

	/**
	 * 
	 */
	protected double assetQuantity;
	
	/**
	 * Default constructor 
	 */
	public AssetResource()
	{
		// TODO Auto-generated constructor stub
	}
	
	/**
	 * 
	 * @param type
	 */
	public AssetResource(AssetType type)
	{
		this.assetType = type;
	}
	
	/**
	 * @return the assetType
	 */
	public AssetType getAssetType()
	{
		return assetType;
	}

	/**
	 * @param assetType the assetType to set
	 */
	public void setAssetType(AssetType assetType)
	{
		this.assetType = assetType;
	}

	/**
	 * @return the assetQuantity
	 */
	public double getAssetQuantity()
	{
		return assetQuantity;
	}

	/**
	 * @param assetQuantity the assetQuantity to set
	 */
	public void setAssetQuantity(double assetQuantity)
	{
		this.assetQuantity = assetQuantity;
	}

	/**
	 * @param addedAsset
	 */
	public double addAsset(double addedAsset)
	{
		this.assetQuantity += addedAsset;
		return this.assetQuantity;
	}
	
	/**
	 * @param pctg
	 */
	public double growAsset(double pctg)
	{
		this.assetQuantity *= (1+pctg);
		return this.assetQuantity;
	}
	
	/**
	 * @param lostAsset
	 * @return
	 */
	public double subtractAsset(double lostAsset)
	{
		this.assetQuantity -= lostAsset;
		return this.assetQuantity;
	}
	
	
	/**
	 * @param pctg
	 * @return
	 */
	public double shrinkAsset(double pctg)
	{
		this.assetQuantity *= (1-pctg);
		return this.assetQuantity;
	}
	
}
