/**
 * 
 */
package sluceii.land.market;

import java.util.ArrayList;

import sluceii.land.market.resource.AssetResource;

/**
 * An interface for all agents that participate in land market activities.

 * @author Shipeng Sun
 *
 */
public interface SimpleMarketAgent 
{
	public int getAgentID();
	public void setAgentID(int id);
	public int getAgentTypeCode();
	
	public ArrayList<Number> getAgentAttributeValueList();
	
	public ArrayList<SimpleMarketLand> getPropertyList();
	public int getPropertyNum();
	public boolean removeProperty(SimpleMarketLand landCommodity);
	public boolean addProperty(SimpleMarketLand landCommodity);
	
	public AssetResource getCapitalResource();
	public double getCapitalResourceQuantity();
	
	public int getX();
	public int getY();
	public void setPosition(float x, float y);
	public void setPosition(int x, int y);
}
