/**
 * SLUCE 2 Project http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.land.market.utility;


/**
 * @author Derek Robinson, Shipeng Sun
 */
public class ModCobbDouglas implements UtilityStrategy
{

	/**
	 * 
	 */
	public ModCobbDouglas()
	{
		// TODO Auto-generated constructor stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sluceii.agent.utility.UtilityStrategy#getName()
	 */
	@Override
	public String getName()
	{
		// TODO Auto-generated method stub
		return "Modified Cobb-Douglas Utility Function, may specify more then 2 factors.";
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @seesluceii.agent.utility.UtilityStrategy#getUtility(sluceii20100204.
	 * ConsumptionBundle)
	 */
	public double getUtility(ConsumptionBundle cb)
	{
		double utilityCalc = Double.NaN;

		if (checkWeightsEqualOne(cb))
		{
			for (int i = 0; i < cb.getSize(); i++)
			{
				utilityCalc = utilityCalc*Math.pow(cb.getObservedValue(i), cb.getPreferenceWeight(i));
			}
		}
		else
		{
			System.out.println("Preference Weights Do not Sum to 1");
		}

		return utilityCalc;
	}

	/**
	 * Check if the weights are corrected specified.
	 * 
	 * @param Consumption Bundle
	 * @return equal to one or not
	 */
	private boolean checkWeightsEqualOne(ConsumptionBundle cb)
	{
		double total = 0;
		for (int i = 0; i < cb.getSize(); i++)
		{
			total = total + cb.getPreferenceWeight(i);
		}

		if (total > 1.0 || total < 0.99)
		{
			return false;
		}
		else
		{
			return true;
		}
	}
}
