/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.params;

/**
 * This class holds most static parameters or constants
 * 
 * @author Shipeng Sun
 *
 */
public class Constants
{

	/**
	 * 
	 */
	public Constants()
	{
		// TODO Auto-generated constructor stub
	}
	
	//***************************************************************
	// Constants imported from SOME model
	//***************************************************************//
	
	public static final int STARTSTEP = 1;
	public static final int INTERVALSTEP = 1;
	
	public static final int MAX_MOORE_NEIGHBORS = 8;
	
	// Distribution types
	public static final int UNIFORM = 0;
	public static final int NORMAL = 1;
	
	// grids and fields
	public static final String AGENT2D = "Agent2D";
	public static final String LANDSCAPE2D = "Landscape2D";
	public static final String LANDUSETYPE = "LandUseType";
	public static final String MANAGEMENTTYPE = "ManagementType";
	public static final String RENTFIELD = "rentfield";
	public static final String BIDPRICEFIELD = "bidPriceField";
	public static final String ASKPRICEFIELD = "askPriceField";
	
	// utilityStrategy
	public static final int UTIL_RANDOM = 0;
	public static final int UTIL_LINEAR = 1;
	public static final int UTIL_COBB_DOUGLAS = 2;
	public static final int UTIL_MOD_COBB_DOUGLAS = 3;
	public static final int UTIL_CES = 4;

	// motivation for supply
	public static final int MO4SUP_RANDOM = 0;
	public static final int MO4SUP_ALL = 1;
	public static final int MO4SUP_DIST_DEPEND = 2;

	// marketAgentType
	public static final int BUYER = 0;
	public static final int SELLER = 1;
	public static final int TRADED = 2;

	
	//***************************************************************
	// Constants imported from ALMA model
	//***************************************************************//

	public static final int B = 70;
	

	// landscape
	public static final int MONOCENTRIC = 0;
	public static final int GREEN_AMENITIES = 1;
	public static final int COAST_WITH_SL = 2;
	public static final int COAST_WITH_PF = 3;
	
	// landCoverType
	public static final int WATER = 0;
	public static final int LAND = 1;
	public static final int PARK_OPEN_SPACE = 2;
	
	
	public static final int HOMO_FRP = 0;
	public static final int HETER_UNIF_FRP = 1;
	public static final int HETER_NORMAL_FRP = 2;
	public static final int HETER_SURVEY_FRP = 3;
	
	
	public static final int FIXED_DAM_COEF = 0;
	public static final int SURVEY_DAM_COEF = 1;
	public static final int UNIFORM_DAM_COEF = 2;
	
	// utilityFunctionType
	public static final int COBB_DOUGLAS = 0;
	public static final int LOGARTHIMIC = 1;
	
	// sellerBehavior
	public static final int AG_LAND_PRICE = 0;
	public static final int AG_SELLER_MARKET_ORIENTED = 1;
	public static final int PURE_WTA = 2;
	public static final int S_NEIGH_ADJUSTMENT = 3;
	public static final int S_MARKET_ORIENTED = 4;
	public static final int S_REFUSED = 5;
	
	// buyerBehavior
	public static final int PURE_WTP = 0;
	public static final int B_MARKET_ORIENTED = 1;
	public static final int RANDOM_BID = 2;
	public static final int B_REFUSED = 3;

}
