###############################################
# Change Log 
# 2011/02/01 Shipeng Sun
#   1. Get everything done within the loop. Do not keep those matrices in memory.
#		
# 2010/08/30 Shipeng Sun
#	1. Land Use layer is not good for transaction because the status of the center is initilized as developed.
#	2. The original distance calculation is confusing. Now changed to internal distance.	
###########################################

# Field Names
# 2011-01-07
# randomSeed, runNumber, msgOutLevel, worldSize, worldSize, worldXCetner, worldYCenter, numBuyer, numSeller, maxBiddingTries, unitTransportCost, neighborhoodSize,meanBudget, sdBudget, numSearchParcel, maxBidNUms, agResPrice, utilityBeta, sdUtilBeta, rangeUtilBeta

# stepNum, luFile, tpFile, luRsltFile, tpRsltFile, transFile

# Run a R-Script file
# source(RCmdFile)

# Set the working directory
#setwd("C:/Users/sunsp/workspace/R-Base/SLUCE2/Data")
#dataPath <- "C:/Users/sunsp/workspace/R-Base/SLUCE2/Data"

source("/Users/Shared/Experiment/2011_05_17/RCode/SLUCE_ASCII_Base_Lib.R")
setwd("/Users/Shared/Experiment/2011_05_17/log")
dataPath <- "/Users/Shared/Experiment/2011_05_17/data"


## read runLog csv file
logName <- "runLog_AAG.csv" #'log_Sample.csv' #'RunLog_04_15.csv' #'runLog_L0_QNTY_04_13.csv'
runLog <- read.csv(file = logName, header = TRUE, sep = ",", quote="\"", dec=".")
fpath <- dataPath

worldSize <- 61
worldXCetner <- 31
worldYCetner <- 31

dist_temp <- matrix(nrow=worldSize,ncol=worldSize)
for(m in 1:worldSize) {
	for(n in 1:worldSize) {
		dist_temp[m,n] <- sqrt((worldXCetner-m)*(worldXCetner-m)+(worldYCetner-n)*(worldYCetner-n))
	}
}

## calculate edge density
edge_density <- matrix()

## calculate mean, max, min transportation cost
mean_trans_cost <- matrix()
max_trans_cost <- matrix()
min_trans_cost <- matrix()

## calculate total, max, min welfare
social_gains <- matrix()
min_social_gains <- matrix()
max_social_gains <- matrix()
## calculate sum of land use changes

sum_luc <- matrix()

## calculate average, max, min transaction price

mean_tp <- matrix()
max_tp <- matrix()
min_tp <- matrix()

numCases = nrow(runLog)

fdimVals <- matrix(nrow=numCases, ncol=2)
ratioDistCoverage <- matrix(nrow=numCases, ncol=3)

require(fdim)

for (i in 1:numCases){

	if(runLog$worldSize[i] != worldSize | worldXCetner != runLog$worldXCetner[i] | worldXCetner != runLog$worldXCetner[i]) {
		worldSize = runLog$worldYCetner[i]
		worldXCetner <- runLog$worldXCetner[i]
		worldYCetner <- runLog$worldSize[i]

		dist_temp <- matrix(nrow=worldSize,ncol=worldSize)
		for(m in 1:worldSize) {
			for(n in 1:worldSize) {
				dist_temp[m,n] <- sqrt((worldXCetner-m)*(worldXCetner-m)+(worldYCetner-n)*(worldYCetner-n))
			}
		}
		
	}
	
	
    tp <- sluce.import.ASCII(paste(fpath,runLog$tpFile[i],sep="/"))
	luA <- matrix(0,nrow=worldSize,ncol=worldSize)
	luA[tp > 0] <- 1
	
	ratioDistCoverage[i,] <- distance.ratio.coverage(dist_temp, c(0.2,0.5,0.8), luA)
	
	edge_density[i] <- sluceii.edge.density(luA)
    #mean_trans_cost[i] <- sum(lu[[i]] * dist_matr) / sum(lu[[i]])
	mean_trans_cost[i] <- sum(luA * dist_temp)/sum(luA)
    trans_matrix <- luA * dist_temp
    max_trans_cost[i] <- max(luA * dist_temp)
    #min_trans_cost[i] <- min(trans_matrix[[i]][trans_matrix[[i]] > 0])
	min_trans_cost[i] <- min(trans_matrix[trans_matrix > 0])
    social_gains[i] <- sum( tp - luA*100 )
    wel_matrix <- tp - luA*100
    min_social_gains[i] <- min ( wel_matrix[wel_matrix > 0] )
    max_social_gains[i] <- max ( tp - luA*100 )	
    sum_luc[i] <- sum(luA)
    mean_tp[i] <- sum(tp)/sum(luA)
    max_tp[i] <- max(tp)
    min_tp[i] <- min(tp[tp > 0])	
	
	fdData <- fdim.data(tp)
	if(dim(fdData)[1] > 0){
		fd <- try(fdim(fdData,1.2,Mnmax=F),F)
		if(class(fd) == 'try-error') {
			fdimVals[i,1] <- 0
		} else
		{
			fdimVals[i,1] <- fd$fdim
		}
		
		fdData[,3] <- 0
		fd <- try(fdim(fdData,1.2,Mnmax=F),F)
		if(class(fd) == 'try-error') {
			fdimVals[i,2] <- 0
		} else
		{
			fdimVals[i,2] <- fd$fdim
		}		
	} else {
		fdimVals[i,] <- c(1.68,1.68) # random distribution 
	}
	
	print(paste("Processing ", i, " th case out of ", numCases, " cases. % ", as.integer(i/numCases*100 + 0.50), sep=""))
}

output <- cbind(runLog,edge_density,mean_trans_cost,max_trans_cost,min_trans_cost,social_gains,max_social_gains,min_social_gains,sum_luc,mean_tp,max_tp,min_tp,fdimVals,ratioDistCoverage)
colnames(output) <- c(colnames(runLog), "edge_density", "mean_tc","max_tc", "min_trans_cost","sum_sw","max_sw","min_sw","sum_luc","mean_tp","max_tp","min_tp","f_dim_3","f_dim_2","dist_ratio_20","dist_ratio_50","dist_ratio_80")
#output <- cbind(runLog,sum_luc,min_tp,max_tp,mean_tp,edge_density,mean_trans_cost,social_gains)
#colnames(output) <- c(colnames(runLog), 'sum_luc','min_tp', 'max_tp','mean_tp', 'edge_density','mean_trans_cost','social_gains')

analysisFileName <- paste(substr(logName,0,nchar(logName)-4), format(Sys.time(), "%Y_%m_%d_%H_%M_%S"),sep="_")
write.csv(output, file=paste(analysisFileName,"csv",sep="."),quote=F,row.names=F)

