require(sp)
require(grDevices)

VER = "Win"
VER = "Mac"

# Set the working directory
if(VER == 'Mac') 
{
	setwd("/Users/Shared/Experiment/2011_03_07/log")
	dataPath <- "/Users/Shared/Experiment/2011_03_07/data"
	source("/Users/Shared/Experiment/2011_03_07/RCode/SLUCE_ASCII_Base_Lib.R")
	
} else if(VER == 'Win')
{
	setwd("C:/Users/sunsp/workspace/R-Base/SLUCE2/Data")
	dataPath <- "C:/Users/sunsp/workspace/R-Base/SLUCE2/Data"
	source("C:/Users/sunsp/workspace/R-Base/SLUCE2/Metrics/SLUCE_ASCII_Base_Lib.R")
}	

fieldNames <- c('maxBidNUms','randomSeed','runNumber','utilityBeta','sdUtilBeta','agResPrice','meanBudget','sdBudget','neighborhoodSize','numSearchParcel','sum_luc','mean_tc','edge_density','mean_tp','sum_sw')
fieldAlias <- c('maxNbid','random','run#','proximity preference (beta)','sd(beta)','Pag','B','sd(B)','r of focal nghr','N search','developed','Avg(TC)','edge dnsty','avg(P)','social welfare')
#prettyNames <- c(expression(bold(maxN[bid])), expression(epsilon), expression(n), expression(bar(beta[u])), expression(sigma[beta[u]]),expression(bolditalic(P[ag])), expression(bold(bar(B))), expression(bold(sigma[B])),expression(r[N]), expression(N[sp]))

logName <- 'runLog_AAG.csv'
logName <- 'runLog_AAG_2011_02_11_15_19_18.csv'
logData <- read.csv(file = logName, header = TRUE, sep = ",", quote="\"", dec=".")

# homogenous agents with different levels of preference for proximity
#filteredLogData <- logData[logData[,'randomSeed'] == 10 & logData[,'neighborhoodSize'] == 2 & logData[,'meanBudget'] == 120 & logData[,'sdBudget'] == 0 & logData[,'numSearchParcel'] > 1 & logData[,'maxBidNUms'] == 1 & logData[,'agResPrice'] < 100 & logData[,'utilityBeta'] > 0 & logData[,'sdUtilBeta'] == 0,]
# heterogeneous agents with different levels of preference 
# filteredLogData <- logData[logData[,'randomSeed'] == 10 & logData[,'neighborhoodSize'] == 2 & logData[,'meanBudget'] == 120 & logData[,'sdBudget'] == 0 & logData[,'numSearchParcel'] > 1 & logData[,'maxBidNUms'] == 1 & logData[,'agResPrice'] < 100 & logData[,'utilityBeta'] == 0.2 & logData[,'sdUtilBeta'] >= 0,]


n <- dim(logData)[1]
totalSteps <- 0
fileType <- "png"

tmp <- "tmp/"
tmpPathName <- paste(getwd(),"/",tmp,sep="")

batchStart = 1
batchEnd = 1

stepNum = 1

staticImageFileNames <- matrix(nrow=n,ncol=2)

for(i in 1:n)
{
	for(j in 1:2)
	{
		if(j == 1) {
			fname <- logData[i,"luFile"]
			fFname <- paste(dataPath,fname,sep="/")
			img <- sluce.read.asciigrid(fFname)
			
		} else if(j == 2)
		{
			fname <- logData[i,"tpFile"]
			fFname <- paste(dataPath,fname,sep="/")
			img <- sluce.read.asciigrid(fFname,nodata=0)
		}
	
		fname <- as.vector(fname)
		subStrs <- strsplit(fname,"_")
		
		if(VER == 'Mac') {
			fExt <- strsplit(fname,"\\.")
		} else if(VER == 'Win')
		{
			fExt <- strsplit(fname,"\\.")
		}
		
		if(subStrs[[1]][1] == "lu")
		{
			stepNum <- subStrs[[1]][10]
			totalTickNum <- subStrs[[1]][11]
			staticFileName <- paste(fExt[[1]][1],fileType,sep=".")
			staticFileName <- paste(tmp,staticFileName,sep="")
			
		} else if (subStrs[[1]][1] == "tprice")
		{
			stepNum <- subStrs[[1]][9]
			totalTickNum <- subStrs[[1]][10]
			staticFileName <- paste(fExt[[1]][1],fileType,sep=".")
			staticFileName <- paste(tmp,staticFileName,sep="")
		}

		staticFileName <- paste(dataPath,staticFileName,sep='/')
		print(staticFileName)
		
		if(VER == 'Mac') 
		{
			if(fileType == "jpg") {
				jpeg(filename = staticFileName, width = 4, height = 4, units = "in", pointsize = 12, quality = 75, bg = "white",res = 600)
			} else if (fileType == "png")
			{
				png(filename = staticFileName, width = 4, height = 4, units = "in", pointsize = 12, bg = "white",res = 600)		
			}

		} else if(VER == 'Win')
		{
			if(fileType == "jpg") {
				jpeg(filename = staticFileName, width = 4, height = 4, units = "in", pointsize = 12, quality = 75, bg = "white",res = 600, restoreConsole = TRUE)
			} else if (fileType == "png")
			{
				png(filename = staticFileName, width = 4, height = 4, units = "in", pointsize = 12, bg = "white",res = 600, restoreConsole = TRUE)		
			}
		}		
		
		if(j == 1)
		{	
			cols <- c(rgb(77, 175, 74, maxColorValue =255), rgb(152, 78, 163, maxColorValue =255))
			image(img,col=cols,add=F)
		} else {
			#terrain.colors(32), heat.colors(32)
			cols <- sluce.rainbow(64, start=0.3, end=0.0)

			par(mai=c(0.1,0.1,0.1,0.1))
			plot(x=c(1,1),xlim=c(0,70),y=c(-9,61),type="n",xlab="",ylab="",axes=F,frame.plot=F)
			image(img,col=cols,add=T,xlim=c(0,61),ylim=c(0,61),frame.plot=T)
			rect(0,0,61,61,border=rgb(0.8,0.8,0.8),lwd=0.5)
			image.legend(60.8,55,range(as.numeric(img@data[,]),na.rm=T,finite=T),col=cols,bty="n",cex=0.60)

			endChar = ","
			paramTxt <- ""
			for(kF in 1:5)
			{
				if(kF == 5) endChar = ""
				paramTxt <- paste(paramTxt, fieldAlias[kF],"=",logData[i,fieldNames[kF]],endChar,sep="")
			}
			#paramTxt <- paste("beta",logData[i,"utilityBeta"],",sd(beta)=",logData[i,"sdUtilBeta"],",budget=",logData[i,"meanBudget"],",sd(budget)=",logData[i,"sdBudget"],sep="")
			#paramTxt <- substitute(expression(paste(prettyNames[4],"=",logData[i,"utilityBeta"],", ", prettyNames[5],"=",logData[i,"sdUtilBeta"],", ", prettyNames[7], "=", logData[i,"meanBudget"],", ", prettyNames[8],"=",logData[i,"sdBudget"],sep="")), list(prettyNames = prettyNames))
			text(2,-2,paramTxt,cex=0.5,pos=4)

			paramTxt <- ""
			endChar = ","
			for(kF in 6:10)
			{
				if(kF == 10) endChar = ""
				paramTxt <- paste(paramTxt,fieldAlias[kF],"=",logData[i,fieldNames[kF]],endChar,sep="")
			}
			#paramTxt <- paste("rnd=",logData[i,"randomSeed"],",nghrSize=",logData[i,"neighborhoodSize"],",numSrch=",logData[i,"numSearchParcel"],",maxBid=",logData[i,"maxBidNUms"],sep="")
			text(2,-5,paramTxt,cex=0.5,pos=4)
			
			paramTxt <- ""
			endChar = ","
			for(kF in 11:15)
			{
				if(kF == 15) endChar = ""
				paramTxt <- paste(paramTxt, fieldAlias[kF],"=",format(logData[i,fieldNames[kF]],digits=4),endChar,sep="")
			}
			text(2,-8,paramTxt,cex=0.5,pos=4)
		}

		dev.off()
		
		staticImageFileNames[i,j] <- staticFileName
	}

	print(paste(stepNum,totalSteps,sep=","))
	
	totalSteps <- totalSteps + 1
}

