###############################################
# Change Log (2010/08/30)
#		Shipeng Sun
#	1. Land Use layer is not good for transaction because the status of the center is initilized as developed.
#	2. The original distance calculation is confusing. Now changed to internal distance.	
###########################################


## read ascii files
ImASCII <- function (file)
{
    zz <- file(file, "r")
    nc <- readLines(zz, 1)
    nc <- strsplit(nc, " ")
    nc <- as.numeric(nc[[1]][length(nc[[1]])])
    nl <- readLines(zz, 1)
    nl <- strsplit(nl, " ")
    nl <- as.numeric(nl[[1]][length(nl[[1]])])
    xll <- readLines(zz, 1)
    xll <- strsplit(xll, " ")
    yll <- readLines(zz, 1)
    yll <- strsplit(yll, " ")
    cs <- readLines(zz, 1)
    cs <- strsplit(cs, " ")
    cs <- as.numeric(cs[[1]][length(cs[[1]])])
    nas <- readLines(zz, 1)
    nas <- strsplit(nas, " ")
    nas <- as.numeric(nas[[1]][length(nas[[1]])])
    close(zz)
    xll = as.numeric(xll[[1]][length(xll[[1]])])
    yll = as.numeric(yll[[1]][length(yll[[1]])])
    output <- scan(file, skip = 6, quiet = TRUE)
    output <- matrix(c(as.matrix(output)), nrow = nc, ncol = nl)
    attr(output, "xll") <- xll
    attr(output, "yll") <- yll
    attr(output, "cellsize") <- cs
    attr(output, "type") <- "numeric"
    class(output) <- "asc"
    attr(output, "filename") <-file
    return(output)
}


## function edge density

Edge_den <- function(land_use)
{
	sum_lands <- sum(land_use)

	counts=0                                                          ## count quantity of edges
	rural_back <- matrix(0, nr = runLog$worldSize[1]+2, nc = runLog$worldSize[1]+2) ## define a background matrix (from 31*31 to 33*33) and set the value as 0

	for (i in 2:runLog$worldSize[1]+1){
		for (j in 2:runLog$worldSize[1]+1){                      ## add the land use map to the background matrix
			rural_back[i,j] <- land_use[i-1,j-1]
			}
	}
	for (i in 2:runLog$worldSize[1]+1){
		for (j in 2:runLog$worldSize[1]+1){   
			if ((rural_back[i,j]==1 & rural_back[i,j-1]==0)){ ## count edges horizontally
				 counts = counts + 2                       ## 2 means edges at both left and right of this patch
				}
			if ((rural_back[i,j]==1 & rural_back[i-1,j]==0)){ ## count edges vertically
				 counts = counts + 2
				}

			}
	}       

	edge_den <- counts / sum_lands

	return(edge_den)
}

# Set the working directory
#setwd("C:/Users/sunsp/workspace/SLUCEII20100204/app/aag/log")
setwd("C:/Users/sunsp/workspace/SLUCEII_AAG/app/aag/log")
#setwd("G:/Realtor_L2")
#setwd("E:/SUN_BACKUP/Projects/GIScientists_Network/R")
#setwd("D:/Courses/Working_Papers/SNA-GIS/R")
#setwd("D:/Courses/Parcel/Modeling/Clustering/Realtor_L2")
dataPath <- "C:/Users/sunsp/workspace/SLUCEII_AAG/app/aag/data/0824"
logName <- 'runLog_AAG_0824_Fixed_Step_2.csv'#'RunLog_04_15.csv' #'runLog_L0_QNTY_04_13.csv'

## read runLog csv file

runLog <- read.csv(file = logName, header = TRUE, sep = ",", quote="\"", dec=".")

# Temporary
runLog[,"luFile"] <- sort(list.files(dataPath,pattern="lu*"))
runLog[,"tpFile"] <- sort(list.files(dataPath,pattern="tp*"))

#lu <- list()
tp <- list()
luA <- list()

fpath <- dataPath
for (i in 1:nrow(runLog)){
    #lu[[i]] <- ImASCII(paste(fpath,runLog$luFile[i],sep="/"))
}

for (i in 1:nrow(runLog)){
    tp[[i]] <- ImASCII(paste(fpath,runLog$tpFile[i],sep="/"))
	luA[[i]] <- matrix(0,nrow=worldSize,ncol=worldSize)
	luA[[i]][tp[[i]] > 0] <- 1
}

worldSize <- 61
dist_temp <- matrix(nrow=worldSize,ncol=worldSize)
for(m in 1:worldSize) {
	for(n in 1:worldSize) {
		dist_temp[m,n] <- sqrt((31-m)*(31-m)+(31-n)*(31-n))
	}
}

dist_matr <- dist_temp[2:(worldSize-1),2:(worldSize-1)]


## calculate edge density
edge_density <- matrix()
for (i in 1:nrow(runLog)){
    edge_density[i] <- Edge_den(luA[[i]])
}

## calculate mean, max, min transportation cost
trans_matrix <- list()
mean_trans_cost <- matrix()
max_trans_cost <- matrix()
min_trans_cost <- matrix()
for (i in 1:nrow(runLog)){
    #mean_trans_cost[i] <- sum(lu[[i]] * dist_matr) / sum(lu[[i]])
	mean_trans_cost[i] <- sum(luA[[i]] * dist_temp)/sum(luA[[i]])
    trans_matrix[[i]] <- luA[[i]] * dist_temp
    max_trans_cost[i] <- max(luA[[i]] * dist_temp)
    #min_trans_cost[i] <- min(trans_matrix[[i]][trans_matrix[[i]] > 0])
	min_trans_cost[i] <- min(trans_matrix[[i]][trans_matrix[[i]] > 0])
}

## calculate total, max, min welfare
wel_matrix <- list()
social_gains <- matrix()
min_social_gains <- matrix()
max_social_gains <- matrix()

for (i in 1:nrow(runLog)){
    social_gains[i] <- sum( tp[[i]] - luA[[i]]*100 )
    wel_matrix [[i]] <- tp[[i]] - luA[[i]]*100
    min_social_gains[i] <- min ( wel_matrix [[i]][wel_matrix [[i]] > 0] )
    max_social_gains[i] <- max ( tp[[i]] - luA[[i]]*100 )
}

## calculate sum of land use changes

sum_luc <- matrix()

for(i in 1:nrow(runLog)){

    sum_luc[i] <- sum(luA[[i]])
}


## calculate average, max, min transaction price

mean_tp <- matrix()
max_tp <- matrix()
min_tp <- matrix()

for(i in 1:nrow(runLog)){

    mean_tp[i] <- sum(tp[[i]])/sum(luA[[i]])
    max_tp[i] <- max(tp[[i]])
    min_tp[i] <- min(tp[[i]][tp[[i]] > 0])
}

output <- cbind(runLog,edge_density,mean_trans_cost,max_trans_cost,min_trans_cost,social_gains,max_social_gains,min_social_gains,sum_luc,mean_tp,max_tp,min_tp)
colnames(output) <- c(colnames(runLog), "edge_density", "mean_tc","max_tc", "min_trans_cost","sum_sw","max_sw","min_sw","sum_luc","mean_tp","max_tp","min_tp")
#output <- cbind(runLog,sum_luc,min_tp,max_tp,mean_tp,edge_density,mean_trans_cost,social_gains)
#colnames(output) <- c(colnames(runLog), 'sum_luc','min_tp', 'max_tp','mean_tp', 'edge_density','mean_trans_cost','social_gains')
write.csv(output, paste(logName, "output1.csv", sep="_"),quote=F,row.names=F)

