#
# This program is used to explore the parameter space.
# Shipeng Sun, Aug, 2010
#

wtp <- 100

# the range of utility is [0,1]
# A^alpha*P^(1-alpha)
b <- seq(0.4, 1, 0.9) # b = 0.4, 
A <- seq(0.1, 1, 0.2) # open space Amenity
P <- seq(0.1, 1, 0.2) # Proximity
alpha <- seq(0.1, 1, 0.2)

maxDist <- 60
distance <- (1-P)*maxDist
UTravelCost <- seq(0.1,1,0.3)

Y <- seq(80, 200, 40)

init <- T

for(bi in 1:length(b))
{
	bv <- b[bi]
	for(Ai in 1:length(A))
	{
		Av <- A[Ai]
		for(Pii in 1:length(P))
		{
			Pv <- P[Pii]
			for(ali in 1:length(alpha))
			{
				alv <- alpha[ali]
				for(di in 1:length(distance))
				{
					dv <- distance[di]
					for(uti in 1:length(UTravelCost))
					{
						utv <- UTravelCost[uti]
						for(yi in 1:length(Y))
						{
							yv <- Y[yi]
							
							rowVal <- cbind(Av,Pv,alv,dv,utv,yv,bv)
							#print(rowVal)
							if(init){
								XVal <- rowVal
								init <- F
							} else {
								XVal <- rbind(XVal, rowVal)
							}
						}
					}
				}
			}
		}
	}
	
}

U <- XVal[,1]^XVal[,3]*XVal[,2]^(1-XVal[,3])
Usq <- U*U
wtp <- (XVal[,6]-XVal[,5])*(Usq/(Usq+(XVal[,7]*XVal[,7])))
XVals <- cbind(XVal, U, wtp)

plot(x=XVals[XVals[,"bv"]==0.1,"dv"], y=XVals[XVals[,"bv"]==0.1,"wtp"])

plot(x=XVals[XVals[,"bv"]==0.4,"dv"], y=XVals[XVals[,"bv"]==0.4,"wtp"])


plot(x=XVals[XVals[,"bv"]==0.7,"dv"], y=XVals[XVals[,"bv"]==0.7,"wtp"])

xx <- seq(0,1,0.02) # utility
bb <- 0.7
rb <- xx^2/(xx^2+bb^2)

setwd("C:/Users/sunsp/workspace/SLUCEII_AAG/app/aag/log")
write.table(XVals,file = "RSim.csv", append = FALSE, quote = FALSE, sep = ",",row.names = FALSE)

# An analytical equation
# The average distance of a grid
adVals <- seq(1,1000)

for(i in 1:1000)
{
	rx <- runif(1000)
	ry <- runif(1000)
	d <- sqrt(rx*rx+ry*ry)
	rd <- d[d<=1.0]
	ad <- ave(rd)[1]
	adVals[i] <- ad
}

ave(adVals)[1] # 0.67 The average distance of a round landscape is 0.67

# the average utility is
(1-0.67)^0.5*0.5^0.5 # 0.40

ru <- seq(0,1,0.01)
rr <- ru*ru/(ru*ru+0.4*0.4)
plot(ru,rr,type='l',xlab="Utility",ylab="Housing Consumption Ratio",ylim=c(0,1))
lines(c(0.4,0.4),c(-0.1,0.5))
lines(c(-0.1,0.4),c(0.5,0.5))
points(0.4,0.5,pch=21)

rr <- ru*ru/(ru*ru+0.2*0.2)
lines(ru,rr)

rr <- ru*ru/(ru*ru+0.8*0.8)
lines(ru,rr)

0.4^2/(0.4^2+0.4^2) # 0.5
100/0.5 + 30*0.67*1 # 220, average housing budget
