#!/bin/bash
# SLUCEII AAG Model Starter
# By Shipeng Sun
# Run the model using
# $ bash start_model.command ./

PWD="${1%/*}"
cd $PWD

REPAST_SIMPHONY_ROOT=$PWD/repast.simphony/repast.simphony.runtime_1.2.0
REPAST_SIMPHONY_BATCH=$PWD/repast.simphony/repast.simphony.batch_1.2.0
REPAST_SIMPHONY_CORE=$PWD/repast.simphony/repast.simphony.core_1.2.0
REPAST_SIMPHONY_SCORE=$PWD/repast.simphony/repast.simphony.score.runtime_1.2.0

REPAST_SIMPHONY_LIB=$REPAST_SIMPHONY_ROOT/lib
REPAST_SIMPHONY_BATCH_LIB=$REPAST_SIMPHONY_BATCH/lib
REPAST_SIMPHONY_CORE_LIB=$REPAST_SIMPHONY_CORE/lib
REPAST_SIMPHONY_SCORE_LIB=$REPAST_SIMPHONY_SCORE/lib

# Define the Core Repast Simphony Directories and JARs
CP=$CP:$REPAST_SIMPHONY_ROOT/bin
CP=$CP:$REPAST_SIMPHONY_ROOT/bin-groovy
CP=$CP:$REPAST_SIMPHONY_BATCH/bin
CP=$CP:$REPAST_SIMPHONY_BATCH/bin-groovy

CP=$CP:$REPAST_SIMPHONY_LIB/*
CP=$CP:$REPAST_SIMPHONY_BATCH_LIB/*
CP=$CP:$REPAST_SIMPHONY_CORE_LIB/*
CP=$CP:$REPAST_SIMPHONY_SCORE_LIB/*

CP=$CP:$PWD/SLUCEII_AAG/lib/helia_gis.jar:$PWD/SLUCEII_AAG/lib/repast.simphony.bin_and_src.jar:$PWD/SLUCEII_AAG/bin

# Change to the Default Repast Simphony Directory
cd $PWD/SLUCEII_AAG

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Change the parameter file as needed
# Check the configuration file path as needed
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++
java -Xss32M -Xmx1024M -cp $CP repast.simphony.batch.BatchMain -params batch/aag_batch_params_boundary_vals_nix.xml -interactive sluce.aag/aag.rs 
