/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.agent.decisionmaking;

import sluceii.landscape.LandCover;

/**
 * This interface specifies how a household/family/resident decide to buy/move.
 * 
 * @author Shipeng Sun
 *
 */
public interface DecisionToBuy
{
	/**
	 * This make yes/no, true/false decision to move
	 * @return if the agent decide to move
	 */
	public boolean isToBuy();
	
	/**
	 * This method generate a probability instead of binary decision
	 * 
	 * @return a probability of buying/moving
	 */
	public double calcBuyProbability();
	
	/**
	 * @param landObj
	 * @return
	 */
	public double calcBidPrice(LandCover landObj);
	
	/**
	 * @param landObj
	 * @return
	 */
	public double calcUtility(LandCover landObj);
	
	/**
	 * @param landObj
	 * @return
	 */
	public double calcWTPPrice(LandCover landObj);
}
