/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.agent.decisionmaking;

import sluceii.landscape.LandCover;

/**
 * @author Shipeng Sun
 *
 */
public interface DecisionToSell
{
	
	/**
	 * Better specify a land object in case a land owner has multiple parcels/subdivisions.
	 * 
	 * @param landObj
	 * @return
	 */
	public boolean isToSell(LandCover landObj);
	
	/**
	 * @param landObj
	 * @return
	 */
	public double calcSellProbability(LandCover landObj);
	
	/**
	 * @param landObj
	 * @return
	 */
	public double calcAskPrice(LandCover landObj);
	
	/**
	 * @param landObj
	 * @return
	 */
	public double calcWTAPrice(LandCover landObj);
}
