/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.agent.decisionmaking;

import repast.simphony.random.RandomHelper;
import sluceii.agent.RuralLandOwner;
import sluceii.app.aag.AAGAppParameters;
import sluceii.landscape.LandCover;
import sluceii.landscape.Parcel;

/**
 * @author Shipeng Sun
 *
 */
public class LandOwnerDecisionToSellHelper implements DecisionToSell
{
	/**
	 * the land owner to sell land
	 */
	RuralLandOwner landOwner;
	
	/**
	 * Default constructor
	 */
	public LandOwnerDecisionToSellHelper()
	{
		// TODO Auto-generated constructor stub
	}
	
	/**
	 * Constructor with land owner initialization
	 * @param ruralLandOwner
	 */
	public LandOwnerDecisionToSellHelper(RuralLandOwner ruralLandOwner)
	{
		// TODO Auto-generated constructor stub
		this.setOwner(ruralLandOwner);
	}
	
	/**
	 * Set the property owner, this might influence the decision to sell.
	 * 
	 * @param ruralLandOwner
	 */
	public void setOwner(RuralLandOwner ruralLandOwner)
	{
		// TODO Auto-generated method stub
		this.landOwner = ruralLandOwner;
	}

	/* (non-Javadoc)
	 * @see sluceii.agent.decisionmaking.DecisionToSell#calcSellProbability()
	 */
	@Override
	public double calcSellProbability(LandCover landObj)
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see sluceii.agent.decisionmaking.DecisionToSell#isToSell()
	 */
	@Override
	public boolean isToSell(LandCover landObj)
	{
		double prob = RandomHelper.nextDouble();
		return (this.landOwner.getPressureToSell() == 1.0f && prob <= AAGAppParameters.sellDecisionUpperBound);
	}

	/* (non-Javadoc)
	 * @see sluceii.agent.decisionmaking.DecisionToSell#calcAskPrice(sluceii.landscape.LandCover)
	 */
	@Override
	public double calcAskPrice(LandCover landObj)
	{
		if(landObj instanceof Parcel)
		{
			// Currently just return the market value
			return ((Parcel)landObj).getMarketValue();
		}
		else
		{
			return 0;
		}
	}

	/* (non-Javadoc)
	 * @see sluceii.agent.decisionmaking.DecisionToSell#calcWTAPrice(sluceii.landscape.LandCover)
	 */
	@Override
	public double calcWTAPrice(LandCover landObj)
	{
		if(landObj instanceof Parcel)
		{
			// Currently just return the market value
			return ((Parcel)landObj).getMarketValue();
		}
		else
		{
			return 0;
		}
	}

}
