/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.agent.resources;

import sluceii.agent.resources.AssetResource.AssetType;

/**
 * @author Shipeng Sun
 * @version 1.0
 * 
 * This class represents the cash flow, income, revenue, all kinds of spending.
 *
 */
public class FlowResource
{
	/**
	 * @author sunsp
	 * Type of flow
	 */
	public enum FlowType {salary, income, revenue, mortage, rent, interest, transit, commuting};
	
	/**
	 * @author sunsp
	 *
	 */
	public enum FlowInterval {daily, weekly, biweekly, monthly, seansonally, annually};
	
	/**
	 * 
	 */
	protected FlowType flowType;
	
	/**
	 * The flow type must be associated to a specific asset type, so it can change an agent's asset.
	 * @see AssetType, capital, land, and labor. 
	 */
	protected AssetType associatedAssetType;
	
	/**
	 * 
	 */
	protected FlowInterval flowUnit;
	
	/**
	 * 
	 */
	protected double flowQuantity;
	
	/**
	 * default constructor
	 */
	public FlowResource()
	{
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param type
	 */
	public FlowResource(FlowType type)
	{
		this.flowType = type;
	}

	/**
	 * @return the flowType
	 */
	public FlowType getFlowType()
	{
		return flowType;
	}

	/**
	 * @param flowType the flowType to set
	 */
	public void setFlowType(FlowType flowType)
	{
		this.flowType = flowType;
	}

	/**
	 * @return the associatedAssetType
	 */
	public AssetType getAssociatedAssetType()
	{
		return associatedAssetType;
	}

	/**
	 * @param associatedAssetType the associatedAssetType to set
	 */
	public void setAssociatedAssetType(AssetType associatedAssetType)
	{
		this.associatedAssetType = associatedAssetType;
	}

	/**
	 * @return the flowUnit
	 */
	public FlowInterval getFlowUnit()
	{
		return flowUnit;
	}

	/**
	 * @param flowUnit the flowUnit to set
	 */
	public void setFlowUnit(FlowInterval flowUnit)
	{
		this.flowUnit = flowUnit;
	}

	/**
	 * @return the flowQuantity
	 */
	public double getFlowQuantity()
	{
		return flowQuantity;
	}

	/**
	 * @param flowQuantity the flowQuantity to set
	 */
	public void setFlowQuantity(double flowQuantity)
	{
		this.flowQuantity = flowQuantity;
	}
	
	
	
	
}
