/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.agent.utility;

import sluceii.agent.utility.ConsumptionBundle;

/**
 * @author Derek Robinson
 *
 */
public class CobbDouglas implements UtilityStrategy
{

	/**
	 * 
	 */
	public CobbDouglas()
	{
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see sluceii.agent.utility.UtilityStrategy#getName()
	 */
	@Override
	public String getName()
	{
		// TODO Auto-generated method stub
		return "Cobb-Douglas Utility Function";
	}

	/* (non-Javadoc)
	 * @see sluceii.agent.utility.UtilityStrategy#getUtility(sluceii20100204.ConsumptionBundle)
	 */
	@Override
	public double getUtility(ConsumptionBundle cb)
	{
		double utilityCalc = Double.NaN;
		
		// Only two elements?
		if(cb.observedValue.size()>=2 && cb.preferenceWeight.size() >= 2)
		{
			utilityCalc = Math.pow(cb.getObservedValue(0), cb.getPreferenceWeight(0));
			utilityCalc = utilityCalc * Math.pow(cb.getObservedValue(1), cb.getPreferenceWeight(1));
		}

		return utilityCalc;
	}

}
