/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.agent.utility;

import sluceii.agent.utility.ConsumptionBundle;

/**
 * The interface specifies how an agent calculates the utility of a property/parcel/house.
 * 
 * @author Derek Robinson, Shipeng Sun
 *
 */
public interface UtilityStrategy
{
	
	/**
	 * @param The bundle of Consumption, including things like accessibility, neighborhood quality,
	 * the number of bedroom, lot size, etc.
	 * 
	 * @return the utility
	 */
	public double getUtility(ConsumptionBundle cb);
	
	/**
	 * @uml.property  name="name"
	 */
	public String getName();
}
