/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.app.aag;

import sluceii.agent.SimpleAgent;
import sluceii.agent.utility.ConsumptionBundle;
import sluceii.landscape.LandCover;
import sluceii.landscape.LandCoverDataHelper;
import sluceii.landscape.Parcel;
import sluceii.landscape.Subdivision;
import sluceii.landscape.LandCover.LandAggregateMethod;
import umn.geog.helia.gis.GISConstants;
import umn.geog.helia.gis.HeliaGIS;
import umn.geog.helia.gis.sa.BasicOperator;
import umn.geog.helia.gis.sa.SimpleSAOperator;
import umn.geog.helia.landscape.RasterLayer;

/**
 * @author sunsp
 *
 */
public class AAGMiscFunctions
{
	private static HeliaGIS hegisObj = new HeliaGIS();
	private static SimpleSAOperator saObj = new SimpleSAOperator();
	/**
	 * 
	 */
	public AAGMiscFunctions()
	{
		// TODO Auto-generated constructor stub
	}
	
	/**
	 * 
	 * @param land the land object, could be a cell, parcel or subdivision,
	 * @param agent the agent who checks out the consumption bundle
	 * @return
	 */
	public static ConsumptionBundle getConsumptionBundle(LandCover land, SimpleAgent agent)
	{
		// TODO: implement this using real data
		ConsumptionBundle cbObj = new ConsumptionBundle();
		RasterLayer<?> envLayer = (RasterLayer<?>)LandCoverDataHelper.rootLayerGroup.getLandscapeLayer(AAGAppParameters.landUseTypeLayerIndex);
		RasterLayer<?> disLayer = (RasterLayer<?>)LandCoverDataHelper.rootLayerGroup.getLandscapeLayer(AAGAppParameters.distanceLayerIndex);
		
		double P = 1- land.getValue(disLayer, LandAggregateMethod.min).doubleValue()/(1+ AAGAppParameters.maxDistanceTo);
		AAGMiscFunctions.saObj.setCurrentOperator(BasicOperator.OperatorType.neighborhoodAverage);
		
		double A = 0.0;
		if(AAGAppParameters.neighborhoodSize > 0)
		{
			A = AAGMiscFunctions.hegisObj.neighborhood(envLayer, land.getXCenterIndex(), land.getYCenterIndex(), GISConstants.neighborhoodCircle, AAGAppParameters.neighborhoodSize, AAGMiscFunctions.saObj).doubleValue();
			
			Number centerVal = envLayer.getValueAt(land.getXCenterIndex(), land.getYCenterIndex());
			if(AAGAppParameters.excludeCenterInNeighborhood)
			{
				if(centerVal.intValue() == 1)
				{
					A = A - 1.0/((2*AAGAppParameters.neighborhoodSize+1)*(2*AAGAppParameters.neighborhoodSize+1));
				}
			}
			else
			{
				if(centerVal.intValue() == 0)
				{
					A = A + 1.0/((2*AAGAppParameters.neighborhoodSize+1)*(2*AAGAppParameters.neighborhoodSize+1));
				}			
			}
		}
		
		A = (A<0)?0:A;
		A=(A>1)?1:A;
		
		A = 1-A;
		
		if(land instanceof Parcel)
		{
			cbObj.addValueToObservedList(P);
			cbObj.addValueToObservedList(A);
			
			//cbObj.addValueToPreferenceWeightList(AAGAppParameters.utilityBeta);
			//cbObj.addValueToPreferenceWeightList(1 - AAGAppParameters.utilityBeta);
			cbObj.addValueToPreferenceWeightList(agent.getPreferenceForProximity());
			cbObj.addValueToPreferenceWeightList(1 - agent.getPreferenceForProximity());
			
		}
		else if(land instanceof Subdivision)
		{
			
		}
		else
		{
			return null;
		}
		
		return cbObj;
	}
}
