/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.app.aag;

import java.awt.Color;
import java.awt.Paint;

import repast.simphony.visualization.visualization2D.style.DefaultValueLayerStyle;

/**
 * @author sunsp
 *
 */
public class LUTypeStyle2D extends DefaultValueLayerStyle
{
	public static double maxVal = -Double.MAX_VALUE;
	public static double minVal =  Double.MAX_VALUE;

	/* (non-Javadoc)
	 * @see repast.simphony.visualization.visualization2D.style.DefaultValueLayerStyle#getBlue(double[])
	 */
	@Override
	public int getBlue(double... coordinates)
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see repast.simphony.visualization.visualization2D.style.DefaultValueLayerStyle#getCellSize()
	 */
	@Override
	public float getCellSize()
	{
		// TODO Auto-generated method stub
		// This size must be the same as the one used for Grid display. Otherwise, their locations
		// will not match.
		// Unfortunately, it is not easy to create a style for grid within the program using Java.
		return 10.0f;
	}

	/* (non-Javadoc)
	 * @see repast.simphony.visualization.visualization2D.style.DefaultValueLayerStyle#getGreen(double[])
	 */
	@Override
	public int getGreen(double... coordinates)
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see repast.simphony.visualization.visualization2D.style.DefaultValueLayerStyle#getRed(double[])
	 */
	@Override
	public int getRed(double... coordinates)
	{
		// TODO Auto-generated method stub
		return 0;
	}

	/**
	 * 
	 */
	public LUTypeStyle2D()
	{
		// TODO Auto-generated constructor stub
		super();
	}

	/* (non-Javadoc)
	 * @see repast.simphony.visualization.visualization2D.style.DefaultValueLayerStyle#getPaint(double[])
	 */
	@Override
	public Paint getPaint(double... coordinates)
	{
		// TODO Auto-generated method stub
		double val = this.layer.get(coordinates);
		
		if(val > LUTypeStyle2D.maxVal) LUTypeStyle2D.maxVal = val;
		if(val > 1 && val < LUTypeStyle2D.minVal) LUTypeStyle2D.minVal = val;

		double maxLuVal = (AAGAppParameters.meanBudget + 2*AAGAppParameters.sdBudget)/(1+AAGAppParameters.bInWTP*AAGAppParameters.bInWTP)*1.000001;
		double minLuVal = AAGAppParameters.agResPrice*0.9999; // zero does not count
		
		int colorSetting = AAGAppParameters.colorSetting;
		
		switch (colorSetting)
		{
			case 0:
			{
				if(val == 0.0)
				{
					return Color.getHSBColor(0,0,0.87f); 
				}
				else if(val == 1.0)
				{
					return Color.darkGray;
				}
				else if(val == -9999)
				{
					return Color.LIGHT_GRAY;
				}
				else
				{
					return blend(Color.black,Color.getHSBColor(0,0,0.77f), (val-minLuVal)/(maxLuVal-minLuVal));
				}				
			}
			case 1:
			{
				if(val == 0.0)
				{
					return Color.green; 
				}
				else if(val == 1.0)
				{
					return Color.darkGray;
				}
				else if(val == -9999)
				{
					return Color.LIGHT_GRAY;
				}
				else
				{
					return blend(Color.red, Color.blue, (val-minLuVal)/(maxLuVal-minLuVal));
				}
			}
			case 2:
			{
				if(val == 0.0)
				{
					return Color.green; 
				}
				else if(val == 1.0)
				{
					return Color.darkGray;
				}
				else if(val == -9999)
				{
					return Color.LIGHT_GRAY;
				}
				else
				{
					return blend(Color.blue, Color.red, (val-minLuVal)/(maxLuVal-minLuVal));
				}
			}			
			case 3:
			{
				if(val == 0.0)
				{
					return Color.green; 
				}
				else if(val == 1.0)
				{
					return Color.darkGray;
				}
				else if(val == -9999)
				{
					return Color.LIGHT_GRAY;
				}
				else
				{
					return blend(new Color(215.0f/256,25.0f/256,28.0f/256), new Color(8.0f/256,48.0f/256, 107.0f/256), (val-minLuVal)/(maxLuVal-minLuVal));
				}
			}						
			default:
			{
				if(val == 0.0)
				{
					return Color.green; 
				}
				else if(val == 1.0)
				{
					return Color.darkGray;
				}
				else if(val == -9999)
				{
					return Color.LIGHT_GRAY;
				}
				else
				{
					return blend(new Color(44.0f/256,123.0f/256, 182.0f/256), new Color(215.0f/256,25.0f/256,28.0f/256), (val-minLuVal)/(maxLuVal-minLuVal));
				}
			}
		}
	}
	
	public static Color blend (Color color1, Color color2, double ratio)
	 {
	   float r  = (float) ratio;
	   r = (r<0.0f)?0.0f:r;
	   r = (r>1.0f)?1.0f:r;
	   float ir = 1f - r;
	   float rgb1[] = new float[3];
	   float rgb2[] = new float[3];
	   color1.getColorComponents(rgb1);
	   color2.getColorComponents(rgb2);
	   Color color = new Color (rgb1[0] * r + rgb2[0] * ir,
	                            rgb1[1] * r + rgb2[1] * ir,
	                            rgb1[2] * r + rgb2[2] * ir);
	   return color;
	 }

}
