/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.app.mn.carver;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Hashtable;

import sluceii.app.aag.AAGAppParameters;
import sluceii.landscape.LandCoverDataHelper;
import sluceii.landscape.Parcel;
import umn.geog.helia.landscape.LandscapeLayer;

/**
 * This class is used to test some components of the system.
 * 
 * @author Shipeng Sun
 * 
 */
public class CodeTester
{

	/**
	 * 
	 */
	public CodeTester()
	{
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		// TODO Auto-generated method stub
		CodeTester test = new CodeTester();
		//test.testLandscapeLoading();
		//test.testAgentInitialization();
		//test.runModel();
		test.arryListTest();
	}
	
	 private void arryListTest()
	{
		// TODO Auto-generated method stub
		 
			DateFormat dateFormat = new SimpleDateFormat("yyyy_MM_dd_HH_mm_ss");
            java.util.Date date = new java.util.Date();
            String datetime = dateFormat.format(date);

            String fileName = "C:\\work\\sun\\aa.txt";
            @SuppressWarnings("unused")
			String timeFileName = fileName.substring(0,fileName.length()-4) + datetime + fileName.substring(fileName.length()-4,fileName.length());

            
		ArrayList<Integer> testAL = new ArrayList<Integer>();
		testAL.add(1);
		testAL.add(100);
		
		if(testAL.contains(100))
		{
			int k = 10;
			testAL.add(k);
		}
		
		Hashtable<Integer, Parcel> tmpDict = new Hashtable<Integer, Parcel>();
		@SuppressWarnings("unused")
		Parcel pp = null;
		for(int i = 1; i < 10; i++)
		{
			Parcel p = new Parcel();
			if(i==7) pp = p;
			tmpDict.put(i,p);
		}
		
		Parcel pObj = tmpDict.get(7);
		
		pObj.addCellID(100);
		pObj.addCellID(200);
		

	}

	/**
	  * See the following post for how to run a model without score file.
	 * http://bellingthetech.wordpress.com/2008/05/06/coding-a-repast-s-model-non-groovy-way/
	 */
	public void runModel()
	 {
		 	
		    String[] args = new String[]{"C:/Users/sunsp/workspace/SLUCEII20100204/sluceii.rs"};
		 
		 	//String[] args = new String[]{"C:/Users/sunsp/workspace/SLUCEII20100204/sluceii20100204.rs"};

		    repast.simphony.runtime.RepastMain.main(args);
	}


	
	/**
	 * @see ModelParameters for setup
	 * @return success or failure
	 */
	@SuppressWarnings("static-access")
	public boolean testLandscapeLoading()
	{
		
		LandCoverDataHelper dataHelper = new LandCoverDataHelper();
		
		dataHelper.loadRootLandscapeLayerGroup();
		
		LandscapeLayer distToDowntown = LandCoverDataHelper.rootLayerGroup.getLandscapeLayer(122);
		float valF = distToDowntown.getValueAt(100, 200).floatValue();
		
		valF += 1.0;
		
		return false;
	}
	
	/**
	 * This method reads and analyzes the csv file that has agent information.
	 * Agents will be created from this file.
	 * @return 
	 */
	public boolean testAgentInitialization()
	{
		File file = new File(AAGAppParameters.agentInitFile);
		BufferedReader bufRdr;
		
		try
		{
			bufRdr = new BufferedReader(new FileReader(file));
			
			String line = null;
			
			// Bypass the header line, the structure of the head line is
			// PIN,EMV_TOTAL,X,Y,Asset,AgentType
			line = bufRdr.readLine();
			String[] values = null;
			
			@SuppressWarnings("unused")
			int pNum;
			@SuppressWarnings("unused")
			double emv, x, y, ast;
			int type;
		
			//read each line of text file
			while((line = bufRdr.readLine()) != null)
			{
				// This is fine as the csv file structure is fixed
				values = line.split(",");
				
				if(values.length == 6)
				{
					pNum = Integer.valueOf(values[0]);
					emv = Double.valueOf(values[1]);
					x   = Double.valueOf(values[2]);
					y   = Double.valueOf(values[3]);
					ast = Double.valueOf(values[4]);
					type = Integer.valueOf(values[5]);
					
					if(type == 0)
					{
						// Rural parcels
						// Context
					}
					else if (type == 1)
					{
						// urban parcels
					}
					else
					{
						
					}
				}
				else
				{
					return false;
				}
			
			}
		
			//close the file
			bufRdr.close();

		}
		catch (FileNotFoundException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch(IOException ioE)
		{
			ioE.printStackTrace();
		}
		
		return true;
	}

}
