/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.land.exchange;

import sluceii.landmarket.LandBidRecord;
import sluceii.landmarket.LandListingRecord;

/**
 * @author Shipeng Sun
 * This is an interface for all land buyers (households, developers).
 * All land buyers on the land market must implement this interface.
 * Without this, the bidding process would not work. 
 */
public interface LandBuyingProcess
{
	/**
	 * Bid on the specified parcel object.
	 * Depending on the limit on the number of bids on a parcel, this may or may not succeed.

	 * @param listedParcelObj
	 * @return if the operation is successful
	 */
	public boolean bidOnParcel(LandListingRecord listedParcelObj);
	
	/**
	 * The seller has accepted this buyer/household's bid
	 */
	public void bidAccepted(LandBidRecord landBidRecord);
	
	/**
	 * @param landBidRecord
	 */
	public void bidRejected(LandBidRecord landBidRecord);
	
	
}
