/**
 * SLUCE 2 Project
 * http://www.cscs.umich.edu/research/projects/sluce/
 */
package sluceii.land.exchange;

import sluceii.landmarket.LandBidRecord;
import sluceii.landscape.Parcel;

/**
 * @author Shipeng Sun
 * This is an interface for all land sellers (rural land owner, household, developer).
 * All land sellers need to implement this interface.
 * The bidding process depends on this interface.
 */
public interface LandSellingProcess
{
	public void putParcelOnMarket(Parcel parcelObj, float askPrice, float wta);
	public void checkBidOffers();
	public void acceptBidOffer(LandBidRecord landBidRecord);
	public void rejectBidOffer(LandBidRecord landBidRecord);
	public void afterBidAction(LandBidRecord landBidRecord);
}
